---
description: 'Something Unique. Hilbish is the new interactive shell for Lua fans. Extensible, scriptable, configurable: All in Lua.'
---

[//]: <>

<!-- hugo (prob goldmark) is funny; the html wont work if its the first thing -->
<div class="text-center">
	<h1 class="fw-light">Something Unique.</h1>
		<p>
			<strong>Hilbish</strong> is the new interactive shell for Lua fans.<br>
			Extensible, scriptable, configurable: All in Lua.
		</p>
	<a href="install" class="btn btn-primary">Install</a>
	<a href="https://github.com/Rosettea/Hilbish" class="btn btn-secondary" target="_blank">Github</a>
</div>

<hr>

<div class="row row-cols-1 row-cols-md-2 g-4">
	<div class="col">
		<div class="card border-light mb-3">
			<div class="row g-0">
				<div class="col-md-4">
					<a href="https://safe.kashima.moe/6njmopm47u1x.png">
						<img src="https://safe.kashima.moe/6njmopm47u1x.png" class="img-fluid rounded-start">
					</a>
				</div>
				<div class="col-md-8">
					<h5 class="card-header">Simple and Easy Scripting</h5>
					<div class="card-body">
						<p class="card-text">
							Hilbish is configured and scripted in the Lua programming language.
							This removes all the old, ugly things about Shell script and introduces
							everything good about Lua, including other languages (Moonscript & Fennel).
						</p>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="col">
		<div class="card border-light mb-3">
			<div class="row g-0">
				<div class="col-md-4">
					<a href="https://safe.kashima.moe/jkndbi636lzj.png">
						<img src="https://safe.kashima.moe/jkndbi636lzj.png" class="img-fluid rounded-start">
					</a>
				</div>
				<div class="col-md-8">
					<h5 class="card-header">History and Completion Menus</h5>
					<div class="card-body">
						<p class="card-text">
							Hilbish provides the user with proper menus for completions,
							history searching. Want to see your previous commands? Hit Ctrl-R.
						</p>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="col">
		<div class="card border-light mb-3">
			<div class="row g-0">
				<div class="col-md-4">
					<a href="https://safe.kashima.moe/6yfeooamzro4.png">
						<img src="https://safe.kashima.moe/6yfeooamzro4.png" class="img-fluid rounded-start">
					</a>
				</div>
				<div class="col-md-8">
					<h5 class="card-header">Tons of Features, and More to Come</h5>
					<div class="card-body">
						<p class="card-text">
							Hilbish offers a bunch of features to make your interactive
							shell experience rich. Things like syntax highlighting and hinting
							available via the Lua API.
						</p>
						<p class="card-small text-muted">* Command hints shown in photo are not default.</p>
					</div>
				</div>
			</div>
		</div>
	</div>
	<!-- uncomment, replace top when editor interface can be replaced (and replace the images) -->
	<!--
	<div class="col">
		<div class="card border-light mb-3">
			<div class="row g-0">
				<div class="col-md-4">
					<a href="https://safe.kashima.moe/6yfeooamzro4.png">
						<img src="https://safe.kashima.moe/6yfeooamzro4.png" class="img-fluid rounded-start">
					</a>
				</div>
				<div class="col-md-8">
					<h5 class="card-header">Highly Extensible</h5>
					<div class="card-body">
						<p class="card-text">
							Hilbish can be turned into an all new shell if wanted. One of our
							main goals is that most (if not all) interfaces can be replaced.
						</p>
					</div>
				</div>
			</div>
		</div>
	</div>
	-->
</div>

<hr>

<h1 class="fw-light">Why not just Lua?</h1>
<p>
	Hilbish is your interactive shell as well as a just a Lua interpreter
	and enhanced REPL.<br>
</p>
<ul class="list-group" style="max-width: 64em;">
	<li class="list-group-item"><i class="fa-solid fa-battery-full"></i> Batteries included Lua runtime that's also your user shell!</li>
	<li class="list-group-item"><i class="fa-solid fa-network-wired"></i> Hilbish is easily cross platform. It has OS agnostic interfaces for easy cross platform Lua code.</li>
</ul>

<hr>

<h1 class="fw-light">Try It Today!</h1>
<p>
	Hilbish is known to run on the 3 major platforms (Windows, MacOS, Linux)
	but likely builds on other Unixes!
	<br>
	Windows doesn't work as well as it should, so if you're a Windows user,
	<a href="https://github.com/Rosettea/Hilbish/discussions/165">say something</a>!
	<ul class="list-group" style="max-width: 64em;">
		<li class="list-group-item"><i class="fa-solid fa-cloud-arrow-down"></i> <a href="/Hilbish/install" style="text-decoration: none;"><strong>Download</strong></a> the binary</li>
		<li class="list-group-item"><i class="fa-solid fa-screwdriver-wrench"></i> <a href="https://github.com/Rosettea/Hilbish#manual-build" style="text-decoration: none;"><strong>Build</strong></a> from source</li>
	</ul>
</p>
